/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <Database.h>
#include <Directory.h>
#include <Set.h>
#include <Dictionary.h>
#include <Array.h>

// group to hold all objects.  maybe should become one group for
// each base assembly eventually.

extern Group* oo7Group;

// Dictionary to hald all base assemblies, indexed by id.
extern Dictionary *AllBaseAssemblies;

// set to hold composite parts.
extern Dictionary *AllCompPartsById;

// collection to hold documents, indexed by Title
extern Dictionary *AllDocumentsByTitle;

// collection to hold documents, indexed by id
extern Dictionary *AllDocumentsById;

// index on module titles
extern Dictionary* AllModulesByName;

// AllPartsByID is a dictionary of all parts, indexed by ID.
extern Dictionary  *AllPartsById;

// AllPartsByDate is a dictionary of all parts, indexed by Date.
extern Dictionary  *AllPartsByDate;

// global var to point to type object to avoid lookups.
extern Type *AtomicPartType;

// global var to point to type object to avoid lookups.
extern Type *ConnectionType;

// global var to point to type object to avoid lookups.
extern Type *CompositePartType;

// global var to point to type object to avoid lookups.
extern Type *DocumentType;

// global var to point to type object to avoid lookups.
extern Type *ManualType;

// a set of "dummy" objects for use in flushing the cache.
extern Set *AllDummyObjects;

// GKK
extern Type *APType;
extern Type *CPType;
extern Type *ASSType;
extern Type *CAType;
extern Type *BAType;
extern Type *CONType;
extern Type *MANType;
extern Type *DOCType;
extern Type *MODType;

#define MARKMODIFIED 1

/*  $Version: globals.h 1.3 93/02/25 10:16:37 Exp $ */


